Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.ntru
Class BigIntPolynomial

    java.lang.Object
      net.sf.ntru.BigIntPolynomial

     class BigIntPolynomial

extends java.lang.Object

Field Summary
`(package private) java.math.BigInteger[]` | `coeffs`

Constructor Summary
`BigIntPolynomial(java.math.BigInteger[] coeffs)`
`BigIntPolynomial(int N)`
`BigIntPolynomial(IntegerPolynomial p)`

Method Summary
`(package private) void` | `add(BigIntPolynomial b)` Adds another polynomial which can have a different number of coefficients
`(package private) void` | `add(BigIntPolynomial b, java.math.BigInteger modulus)`
`(package private) void` | `clear()`
`BigIntPolynomial` | `clone()`
`(package private) void` | `div(java.math.BigInteger divisor)`
`(package private) static BigIntPolynomial` | `generateRandomSmall(int N, int numOnes, int numNegOnes)`
`(package private) void` | `mod(java.math.BigInteger modulus)`
`(package private) void` | `mult(java.math.BigInteger factor)`
`(package private) BigIntPolynomial` | `mult(BigIntPolynomial poly2)` Multiplies the polynomial with another, taking the indices mod N
`(package private) BigIntPolynomial` | `mult(BigIntPolynomial poly2, java.math.BigInteger modulus)`
`(package private) void` | `mult(int factor)`
`(package private) BigIntPolynomial` | `mult(IntegerPolynomial poly2)`
`private BigIntPolynomial` | `multRecursive(BigIntPolynomial poly2)` Karazuba multiplication
`(package private) BigIntPolynomial` | `multSimple(BigIntPolynomial poly2)` O(n²) multiplication
`(package private) void` | `sub(BigIntPolynomial b)` Subtracts another polynomial which can have a different number of coefficients
`(package private) java.math.BigInteger` | `sumCoeffs()`

Methods inherited from class java.lang.Object
`equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### coeffs

    java.math.BigInteger[] coeffs

Constructor Detail

### BigIntPolynomial

    BigIntPolynomial(int N)

### BigIntPolynomial

    BigIntPolynomial(IntegerPolynomial p)

### BigIntPolynomial

    BigIntPolynomial(java.math.BigInteger[] coeffs)

Method Detail

### generateRandomSmall

    static BigIntPolynomial generateRandomSmall(int N,
                                                int numOnes,
                                                int numNegOnes)

### mult

    BigIntPolynomial mult(BigIntPolynomial poly2,
                          java.math.BigInteger modulus)

### mult

    BigIntPolynomial mult(IntegerPolynomial poly2)

### mult

    BigIntPolynomial mult(BigIntPolynomial poly2)

  Multiplies the polynomial with another, taking the indices mod N

### multRecursive

    private BigIntPolynomial multRecursive(BigIntPolynomial poly2)

  Karazuba multiplication

### multSimple

    BigIntPolynomial multSimple(BigIntPolynomial poly2)

  O(n²) multiplication

### add

    void add(BigIntPolynomial b,
             java.math.BigInteger modulus)

### add

    void add(BigIntPolynomial b)

  Adds another polynomial which can have a different number of coefficients

### sub

    void sub(BigIntPolynomial b)

  Subtracts another polynomial which can have a different number of coefficients

### mult

    void mult(java.math.BigInteger factor)

### mult

    void mult(int factor)

### div

    void div(java.math.BigInteger divisor)

### mod

    void mod(java.math.BigInteger modulus)

### sumCoeffs

    java.math.BigInteger sumCoeffs()

### clear

    void clear()

### clone

    public BigIntPolynomial clone()

  Overrides:
    `clone` in class `java.lang.Object`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD